<begin>

class DoCmd /// Commands using database objects ///
{
[methods:
	[id(0x000003eb), helpstring("method Beep")]
	HRESULT Beep();
	[id(0x000003f0), helpstring("method Echo")]
	HRESULT Echo(VARIANT EchoOn, VARIANT StatusBarText);
	[id(0x000003f7), helpstring("method Maximize")]
	HRESULT Maximize();
	[id(0x000003f8), helpstring("method Minimize")]
	HRESULT Minimize();
	[id(0x000003f9), helpstring("method MoveSize")]
	HRESULT MoveSize(VARIANT Right, VARIANT Down, VARIANT Width, VARIANT Height);
	[id(0x000003fb), helpstring("method OpenDBForm")]
	HRESULT OpenDBForm(VARIANT FormName);
	[id(0x000003fc), helpstring("method OpenQuery")]
	HRESULT OpenQuery(VARIANT QueryName);
	[id(0x000003fd), helpstring("method OpenTable")]
	HRESULT OpenTable(VARIANT Name);
	[id(0x00000600), helpstring("method OpenRelation")]
	HRESULT OpenRelation(VARIANT RelationName);

	[id(0x000003ff), helpstring("method Quit")]
	HRESULT Quit(AbdQuitOption Options);
	[id(0x0000040f), helpstring("method OpenReport")]
	HRESULT OpenReport(VARIANT ReportName);

	[id(0x00000403), helpstring("method Restore")]
	HRESULT Restore();

	[id(0x00000406), helpstring("method RunMacro")]
	HRESULT RunMacro( VARIANT MacroName, VARIANT RepeatCount);
]
};


class Application //////
{
[properties:
	[id(0x000007d5), propget, helpstring("property Application")]
	HRESULT Application([retval] Application **ppRet);
	[id(0x00000827), propget, helpstring("property Parent")]
	HRESULT Parent([retval] IDispatch **ppRet);
	[id(0x000007db), propget, helpstring("property CurrentObjectType")]
	HRESULT CurrentObjectType([retval] AbdObjectType *pRet);
	[id(0x000007dc), propget, helpstring("property CurrentObjectName")]
	HRESULT CurrentObjectName([retval] BSTR *pRet);
	[id(0x000007d2), propget, helpstring("property DBForms")]
	HRESULT DBForms([retval] IDBForms **ppRet);
	[id(0x000007d3), propget, helpstring("property Queries")]
	HRESULT Queries([retval] IQueries **ppRet);
	[id(0x000007d4), propget, helpstring("property Relations")]
	HRESULT Relations([retval] IRelations **ppRet);
	[id(0x000007d6), propget, helpstring("property Reports")]
	HRESULT Reports([retval] IReports **ppRet);
	[id(0x000007d7), propget, helpstring("property Tables")]
	HRESULT Tables([retval] ITables **ppRet);
	[id(0x000007e9), propget, helpstring("property DoCmd")]
	HRESULT DoCmd([retval] IDoCmd **pRet);
	[id(0x00000864), propget, helpstring("property Visible")]
	HRESULT Visible([retval] VARIANT_BOOL *pfVisible);
	[id(0x00000864), propput, helpstring("property Visible")]
	HRESULT Visible(VARIANT_BOOL fVisible);
	[id(0x00000865), propget, helpstring("property UserControl")]
	HRESULT UserControl([retval] VARIANT_BOOL *pfUserCtrl);
	[id(0x00000865), propput, helpstring("property UserControl")]
	HRESULT UserControl(VARIANT_BOOL fUserCtrl);
	[id(0x0000083e), propget, helpstring("property DBEngine")]
	HRESULT DBEngine([retval] DBEngine **ppRet );
	[propget, id(1), helpstring("property Databases")] 
	HRESULT Databases([retval] IDatabases* *pVal);
	[propget, id(2), helpstring("property ActiveDatabase")] 
	HRESULT ActiveDatabase([retval] IDatabase* *pVal);
	[propget, id(3), helpstring("property ActiveDataObject")] 
	HRESULT ActiveDataObject([retval] IDispatch* *pVal);
	[propget, id(4), helpstring("property ActiveRecord")] 
	HRESULT ActiveRecord([retval] Fields* *pVal);


	[id(0x000006d2), propget, helpstring("property ToolbarsVisible")]
	HRESULT ToolbarsVisible([retval] VARIANT_BOOL *pfVisible);
	[id(0x000006d2), propput, helpstring("property ToolbarsVisible")]
	HRESULT ToolbarsVisible(VARIANT_BOOL fVisible);
	
	[id(0x000006d3), propget, helpstring("property MenusVisible")]
	HRESULT MenusVisible([retval] VARIANT_BOOL *pfVisible);
	[id(0x000006d3), propput, helpstring("property MenusVisible")]
	HRESULT MenusVisible(VARIANT_BOOL fVisible);




]
[methods:
	[id(0x0000085e), helpstring("method NewCurrentDatabase")]
	HRESULT NewCurrentDatabase(BSTR filepath);
	[id(0x0000085c), helpstring("method OpenCurrentDatabase")]
	HRESULT OpenCurrentDatabase(BSTR filepath, VARIANT_BOOL Exclusive);
	[id(0x000007df), helpstring("method Echo")]
	HRESULT Echo(short EchoOn, BSTR bstrStatusBarText);
	[id(0x0000085d), helpstring("method CloseCurrentDatabase")]
	HRESULT CloseCurrentDatabase();
	[id(0x000007e0), helpstring("method Quit")]
	HRESULT Quit(AbdQuitOption Option);
	[id(0x00000801), helpstring("method CurrentDb")]
	HRESULT CurrentDb([retval] Database **ppRet);
	[id(0x0000086e), helpstring("method RefreshTitleBar")]
	HRESULT RefreshTitleBar();
	[id(0x0000088a), helpstring("method RefreshDatabaseWindow")]
	HRESULT RefreshDatabaseWindow();
]
};


class DBForms //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval DBForm **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
[methods:
	[id(1), helpstring("method Open")] 
	HRESULT Open(VARIANT Index, [retval]DBForm** ppRet);
]
};

class Tables //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval ABTable **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
[methods:
	[id(1), helpstring("method Open")] 
	HRESULT Open(VARIANT Index, [retval]ABTable** ppRet);
]
};

class Queries //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval ABQuery **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
[methods:
	[id(1), helpstring("method Open")] 
	HRESULT Open(VARIANT Index, [retval]ABQuery** ppRet);
]
};

class Relations //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval ABRelation **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
[methods:
	[id(1), helpstring("method Open")] 
	HRESULT Open(VARIANT Index, [retval]ABRelation** ppRet);
]
};


class Properties //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval IDispatch **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
};

class DBForm //////
{
[properties:
	[id(0x00000027), propget, helpstring("property Name")]
	HRESULT Name( retval BSTR *pRet);
	[id(0x00000027), propput, helpstring("property Name")]
	HRESULT Name( BSTR Val);

	[id(0x00000829), propget, helpstring("property DBForm")]
	HRESULT DBForm([retval] DBForm **ppRet);
	[id(0x0000082b), propget, helpstring("property Properties")]
	HRESULT Properties([retval] IProperties **ppRet);

	[id(00000000), propget, helpstring("property Controls")]
	HRESULT Controls( retval IControls **ppRet);
	[propget, id(3), helpstring("property Database")] 
	HRESULT Database([retval] IDatabase* *pVal);
	[propget, id(4), helpstring("property Type")] 
	HRESULT Type([retval] long *pVal);

	[id(0x0000014e), propget, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord([retval] long *pRet);


	[propget, id(0x0000085d), helpstring("property NoMatch")] 
	HRESULT NoMatch(retval VARIANT_BOOL *pVal);

	[id(1), helpstring("property Fields")]
	HRESULT Fields( retval Fields ** ppRet);
	
	[propget, id(0x000000f8), helpstring("property RecordCount")] 
	HRESULT RecordCount(retval long *pVal);

	[id(0x0000010f), propget, helpstring("property Filter")]
	HRESULT Filter([retval] BSTR *pRet);
	[id(0x0000010f), propput, helpstring("property Filter")]
	HRESULT Filter(BSTR Val);

	[propget, id(0x000003f8), helpstring("property BOF")] 
	HRESULT BOF([retval] VARIANT_BOOL *pVal);
	[propget, id(0x000003f9), helpstring("property EOF")] 
	HRESULT EOF([retval] VARIANT_BOOL *pVal);

]
[methods:
	[id(1), helpstring("method Close")]
	HRESULT Close();
	[id(2), helpstring("method Activate")]
	HRESULT Activate();

	[id(0x0000082a), helpstring("method MoveFirst")]
	HRESULT MoveFirst();
	[id(0x0000082f), helpstring("method MoveLast")]
	HRESULT MoveLast();
	[id(0x0000082e), helpstring("method MoveNext")]
	HRESULT MoveNext();
	[id(0x0000082d), helpstring("method MovePrevious")]
	HRESULT MovePrevious();
	[id(0xfffffdda), helpstring("method Refresh")]
	HRESULT Refresh();

	[id(0x000003f2), helpstring("method FindNext")]
	HRESULT FindNext(BSTR FindCriteria); 
	[id(0x000003f3), helpstring("method FindPrevious")]
	HRESULT FindPrevious(BSTR FindCriteria); 
	[id(0x000003f4), helpstring("method FindFirst")]		
	HRESULT FindFirst(BSTR FindCriteria); 
	[id(0x000003f5), helpstring("method FindLast")]
	HRESULT FindLast(BSTR FindCriteria); 

	[id(0x000003f6), helpstring("method Move")]
	HRESULT Move(long RecordNumber); 
	[id(0x000003f7), helpstring("method DeleteRecord")]
	HRESULT DeleteRecord(); 
	[id(0x000004f9), helpstring("method AddNewRecord")]
	HRESULT AddNewRecord();
	[id(0x000004f7), helpstring("method EditRecord")]
	HRESULT EditRecord();
	[id(0x000004f8), helpstring("method UpdateRecord")]
	HRESULT UpdateRecord();

]
};


class Report //////
{
[properties:

	[id(0x00000027), propget, helpstring("property ReportName")]
	HRESULT ReportName([retval] BSTR *pRet);
	[id(0x00000014), propget, helpstring("property Name")]
	HRESULT Name([retval] BSTR *pRet);
	[id(0x0000082b), propget, helpstring("property Properties")]
	HRESULT Properties([retval] IProperties **ppRet);
	[id(00000000), propget, helpstring("property Controls")]
	HRESULT Controls([retval] IControls **ppRet);

	[propget, id(3), helpstring("property Database")] 
	HRESULT Database([retval] IDatabase* *pVal);
	[propget, id(4), helpstring("property Type")] 
	HRESULT Type([retval] long *pVal);
	[id(2097), propget, helpstring("property Report")]
	HRESULT Report( retval Report **ppRet);
]
[methods:
	[id(2153), helpstring("method Print")]
	HRESULT Print();
	[id(1), helpstring("method Close")]
	HRESULT Close();
	[id(2), helpstring("method Activate")]
	HRESULT Activate();
]
};

class Reports //////
{
[properties:
	[id(2005), propget, helpstring("property Application")]
	HRESULT Application( retval Application **ppRet);
	[id(2087), propget, helpstring("property Parent")]
	HRESULT Parent( retval IDispatch **ppRet);
	[id(00000000), propget, helpstring("property Item")]
	HRESULT Item( VARIANT Index,  retval Report **ppRet);
	[id(2001), propget, helpstring("property Count")]
	HRESULT Count( retval long *pRet);
]
[methods:
	[id(1), helpstring("method Open")] 
	HRESULT Open(VARIANT Index, [retval]Report** ppRet);
]
};


class AbDataProperty //////
{
[properties:
    [id(2005), propget, helpstring("property Application")]
    HRESULT Application( [retval] Application **ppRet);
    [id(2087), propget, helpstring("property Parent")]
    HRESULT Parent( [retval] IDispatch **ppRet);
]
};

class Database //////
{
[properties:
	[propget, id(2), helpstring("property Tables")] 
	HRESULT Tables([retval] ITables* *pVal);
	[propget, id(3), helpstring("property Querys")] 
	HRESULT Queries([retval] IQueries* *pVal);
	[propget, id(4), helpstring("property Relations")] 
	HRESULT Relations([retval] IRelations* *pVal);
	[propget, id(5), helpstring("property DBForms")] 
	HRESULT DBForms([retval] IDBForms* *pVal);
	[propget, id(6), helpstring("property Reports")] 
	HRESULT Reports([retval] IReports* *pVal);
	[propget, id(9), helpstring("property Name")]
	HRESULT Name([retval] BSTR *pVal);
	[propget, id(10), helpstring("property Admin")]
	HRESULT Admin([retval] Database* *pVal);
]
[methods:
	[id(8), helpstring("method Close")] 
	HRESULT Close();
	[id(11), helpstring("method Execute")] 
	HRESULT Execute(BSTR SQLStat);

]
};

class Databases //////
{
[properties:
	[propget, id(8), helpstring("property Application")]
	HRESULT Application([retval] IDispatch* *pVal);
	[propget, id(0), helpstring("property Item")]
	HRESULT Item(VARIANT Index, [retval] IDatabase* *pVal);
	[propget, id(10), helpstring("property Count")] 
	HRESULT Count([retval] long *pVal);
]
[methods:
	[id(5), helpstring("method Open")]
	HRESULT Open(BSTR fileName, VARIANT_BOOL exclusive);
	[id(6), helpstring("method Add")]
	HRESULT Add(BSTR filepath);
]
};

	
class BField //////
{
[properties:
	[id(0x00000014), propget, helpstring("property Name")]
	HRESULT Name([retval] BSTR *pRet);
	[id(0x00000014), propput, helpstring("property Name")]
	HRESULT Name(BSTR pRet);

	[id(0x0000001c), propget, helpstring("property BackColor")]
	HRESULT BackColor([retval] long *pRet);
	[id(0x000000cb), propget, helpstring("property ForeColor")]
	HRESULT ForeColor([retval] long *pRet);
	[id(0x000000cb), propput, helpstring("property ForeColor")]
	HRESULT ForeColor(long pRet);

	[id(0x00000022), propget, helpstring("property FontName")]
	HRESULT FontName([retval] BSTR *pRet);
	[id(0x00000022), propput, helpstring("property FontName")]
	HRESULT FontName(BSTR pRet);
	[id(0x00000023), propget, helpstring("property FontSize")]
	HRESULT FontSize([retval] short *pRet);
	[id(0x00000023), propput, helpstring("property FontSize")]
	HRESULT FontSize(short pRet);
	[id(0x00000025), propget, helpstring("property FontWeight")]
	HRESULT FontWeight([retval] short *pRet);
	[id(0x00000025), propput, helpstring("property FontWeight")]
	HRESULT FontWeight(short pRet);
	[id(0x00000021), propget, helpstring("property FontItalic")]
	HRESULT FontItalic([retval] VARIANT_BOOL *pRet);
	[id(0x00000021), propput, helpstring("property FontItalic")]
	HRESULT FontItalic(VARIANT_BOOL pRet);
	[id(0x00000020), propget, helpstring("property FontBold")]
	HRESULT FontBold([retval] short *pRet);
	[id(0x00000020), propput, helpstring("property FontBold")]
	HRESULT FontBold(short pRet);
]
};


class Table //////
{
[properties:

	[propget, id(0x0000000D), helpstring("property Database")] 
	HRESULT Database([retval] IDatabase* *pVal);
	[propget, id(0x0000000E), helpstring("property Type")] 
	HRESULT Type([retval] long *pVal);
	[id(1), helpstring("property Fields")]
	HRESULT Fields( retval Fields ** ppRet);
	[id(2), propget, helpstring("property Name")]
	HRESULT Name( retval BSTR * pVal);
	[id(7), propget, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( retval long * pRet);
	[id(7), propput, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( long pRet);
	[propget, id(0x00000010), helpstring("property RecordCount")]
	HRESULT RecordCount(retval long *pVal);
	[propget, id(0x00000011), helpstring("property BOF")]
	HRESULT BOF(retval VARIANT_BOOL *pVal);
	[propget, id(0x00000012), helpstring("property EOF")]
	HRESULT EOF(retval VARIANT_BOOL *pVal);
	
	[propget, id(0x0000085d), helpstring("property NoMatch")] 
	HRESULT NoMatch(retval VARIANT_BOOL *pVal);

	[id(0x0000010f), propget, helpstring("property Filter")]
	HRESULT Filter([retval] BSTR *pRet);
	[id(0x0000010f), propput, helpstring("property Filter")]
	HRESULT Filter(BSTR Val);

]
[methods:
	[id(0x00000008), helpstring("method EditRecord")]
	HRESULT EditRecord();
	[id(0x00000009), helpstring("method AddNewRecord")]
	HRESULT AddNewRecord();
	[id(0x0000000A), helpstring("method UpdateRecord")]
	HRESULT UpdateRecord();

	[id(3), helpstring("method MoveFirst")]
	HRESULT MoveFirst();
	[id(4), helpstring("method MoveLast")]
	HRESULT MoveLast();
	[id(5), helpstring("method MoveNext")]
	HRESULT MoveNext();
	[id(6), helpstring("method MovePrevious")]
	HRESULT MovePrevious();
	[id(0x0000000B), helpstring("method Close")]
	HRESULT Close();
	[id(0x0000000C), helpstring("method Activate")] 
	HRESULT Activate();

	[id(0x000003f2), helpstring("method FindNext")]
	HRESULT FindNext(BSTR FindCriteria); 
	[id(0x000003f3), helpstring("method FindPrevious")]
	HRESULT FindPrevious(BSTR FindCriteria); 
	[id(0x000003f4), helpstring("method FindFirst")]		
	HRESULT FindFirst(BSTR FindCriteria); 
	[id(0x000003f5), helpstring("method FindLast")]
	HRESULT FindLast(BSTR FindCriteria); 

	[id(0x000003f6), helpstring("method Move")]
	HRESULT Move( long RecordNumber); 

	[id(0x000003f7), helpstring("method DeleteRecord")]
	HRESULT DeleteRecord(); 
	[id(0xfffffdda), helpstring("method Refresh")]
	HRESULT Refresh();



]
};	


class Query //////
{
[properties:
	[propget, id(0x0000000D), helpstring("property Database")] 
	HRESULT Database([retval] IDatabase* *pVal);
	[propget, id(0x0000000E), helpstring("property Type")] 
	HRESULT Type([retval] long *pVal);
	[id(1), helpstring("property Fields")]
	HRESULT Fields( retval Fields ** ppRet);
	[id(2), propput, helpstring("property Name")]
	HRESULT Name( retval BSTR * pVal);
	[id(2), propget, helpstring("property Name")]
	HRESULT Name( BSTR Val);
	[id(7), propget, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( retval long * pRet);
	[id(7), propput, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( long pRet);
	[propget, id(0x00000010), helpstring("property RecordCount")]
	HRESULT RecordCount(retval long *pVal);
	[propget, id(0x00000011), helpstring("property BOF")]
	HRESULT BOF(retval VARIANT_BOOL *pVal);
	[propget, id(0x00000012), helpstring("property EOF")]
	HRESULT EOF(retval VARIANT_BOOL *pVal);

	[propget, id(0x0000085d), helpstring("property NoMatch")] 
	HRESULT NoMatch(retval VARIANT_BOOL *pVal);

	[id(0x0000010f), propget, helpstring("property Filter")]
	HRESULT Filter([retval] BSTR *pRet);
	[id(0x0000010f), propput, helpstring("property Filter")]
	HRESULT Filter(BSTR Val);

]
[methods:

	[id(0x00000008), helpstring("method EditRecord")]
	HRESULT EditRecord();
	[id(0x00000009), helpstring("method AddNewRecord")]
	HRESULT AddNewRecord();
	[id(0x0000000A), helpstring("method UpdateRecord")]
	HRESULT UpdateRecord();

	[id(3), helpstring("method MoveFirst")]
	HRESULT MoveFirst();
	[id(4), helpstring("method MoveLast")]
	HRESULT MoveLast();
	[id(5), helpstring("method MoveNext")]
	HRESULT MoveNext();
	[id(6), helpstring("method MovePrevious")]
	HRESULT MovePrevious();
	[id(0x0000000B), helpstring("method Close")]
	HRESULT Close();
	[id(0x0000000C), helpstring("method Activate")]
	HRESULT Activate();

	[id(0x000003f2), helpstring("method FindNext")]
	HRESULT FindNext(BSTR FindCriteria); 
	[id(0x000003f3), helpstring("method FindPrevious")]
	HRESULT FindPrevious(BSTR FindCriteria); 
	[id(0x000003f4), helpstring("method FindFirst")]		
	HRESULT FindFirst(BSTR FindCriteria); 
	[id(0x000003f5), helpstring("method FindLast")]
	HRESULT FindLast(BSTR FindCriteria); 

	[id(0x00000018), helpstring("method Move")]
	HRESULT Move(long RecordNumber); 

	[id(0x000003f7), helpstring("method DeleteRecord")]
	HRESULT DeleteRecord(); 
	[id(0xfffffdda), helpstring("method Refresh")]
	HRESULT Refresh();
]
};	

class Controls ///////
{
[properties:
		[id(0x000007d5), propget, helpstring("property Application")]
		HRESULT Application( [retval] Application **ppRet);

		[id(0x00000827), propget, helpstring("property Parent")]
		HRESULT Parent([retval] IDispatch **ppRet);

		[id(00000000), propget, helpstring("property Item")]
		HRESULT Item(VARIANT Index,  [retval] IDispatch **ppRet);

		[id(0x000007d1), propget, helpstring("property Count")]
		HRESULT Count( [retval] long *pRet);
]
};

class Relation //////
{
[properties:
	[propget, id(0x0000000D), helpstring("property Database")] 
	HRESULT Database([retval] IDatabase* *pVal);
	[propget, id(0x0000000E), helpstring("property Type")] 
	HRESULT Type([retval] long *pVal);
	[id(1), helpstring("property Fields")]
	HRESULT Fields( retval Fields ** ppRet);
	[id(2), propget, helpstring("property Name")]
	HRESULT Name( retval BSTR * pVal);
	[id(2), propput, helpstring("property Name")]
	HRESULT Name( BSTR Val);
	[id(7), propget, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( retval long * pRet);
	[id(7), propput, helpstring("property CurrentRecord")]
	HRESULT CurrentRecord( long pRet);
	[propget, id(0x00000010), helpstring("property RecordCount")]
	HRESULT RecordCount(retval long *pVal);
	[propget, id(0x00000011), helpstring("property BOF")]
	HRESULT BOF(retval VARIANT_BOOL *pVal);
	[propget, id(0x00000012), helpstring("property EOF")]
	HRESULT EOF(retval VARIANT_BOOL *pVal);

	[propget, id(0x0000085d), helpstring("property NoMatch")] 
	HRESULT NoMatch(retval VARIANT_BOOL *pVal);

	[id(0x0000010f), propget, helpstring("property Filter")]
	HRESULT Filter([retval] BSTR *pRet);
	[id(0x0000010f), propput, helpstring("property Filter")]
	HRESULT Filter(BSTR Val);

]
[methods:
	[id(0x00000008), helpstring("method EditRecord")]
	HRESULT EditRecord();
	[id(0x00000009), helpstring("method AddNewRecord")]
	HRESULT AddNewRecord();
	[id(0x0000000A), helpstring("method UpdateRecord")]
	HRESULT UpdateRecord();
	
	[id(3), helpstring("method MoveFirst")]
	HRESULT MoveFirst();
	[id(4), helpstring("method MoveLast")]
	HRESULT MoveLast();
	[id(5), helpstring("method MoveNext")]
	HRESULT MoveNext();
	[id(6), helpstring("method MovePrevious")]
	HRESULT MovePrevious();
	[id(0x0000000B), helpstring("method Close")]
	HRESULT Close();
	[id(0x0000000C), helpstring("method Activate")] 
	HRESULT Activate();

	[id(0x000003f2), helpstring("method FindNext")]
	HRESULT FindNext(BSTR FindCriteria); 
	[id(0x000003f3), helpstring("method FindPrevious")]
	HRESULT FindPrevious(BSTR FindCriteria); 
	[id(0x000003f4), helpstring("method FindFirst")]		
	HRESULT FindFirst(BSTR FindCriteria); 
	[id(0x000003f5), helpstring("method FindLast")]
	HRESULT FindLast(BSTR FindCriteria); 

	[id(0x000003f6), helpstring("method Move")]
	HRESULT Move(long RecordNumber); 
	[id(0xfffffdda), helpstring("method Refresh")]
	HRESULT Refresh();

]
};	
